Index: src/binutils/cfg.sh
===================================================================
RCS file: src/binutils/cfg.sh
diff -N src/binutils/cfg.sh
--- nul	1 Jan 1970 00:00:00 -0000
+++ src/binutils/cfg.sh	25 Sep 2003 19:27:00 -0000	1.1
@@ -0,0 +1,11 @@
+# This scripts tries to do the best to configure binutils on OS/2
+
+# Unset LEX and YACC variables since otherwise it triggers a bug in
+# binutils' autoconf
+export LEX; unset LEX
+export YACC; unset YACC
+
+#./configure --prefix=/gcc &&
+#	make configure-host
+
+make configure-binutils
Index: src/binutils/configure.in
===================================================================
RCS file: /gccos2/src/binutils/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/configure.in	16 Aug 2003 16:40:53 -0000	1.1.1.2
+++ src/binutils/configure.in	25 Sep 2003 19:27:00 -0000	1.4
@@ -1085,6 +1085,9 @@
   i[[3456]]86-*-msdosdjgpp*)
     host_makefile_frag="config/mh-djgpp"
     ;;
+  i[3456]86-*-os2*)
+    host_makefile_frag="config/mh-emx"
+    ;;
   *-cygwin*)
     host_makefile_frag="config/mh-cygwin"
     ;;
@@ -1253,7 +1256,7 @@
   found=
   for dir in $PATH; do
     test -z "$dir" && dir=.
-    if test -f $dir/gcc; then
+    if test -f $dir/gcc${ac_cv_exeext}; then
       found=yes
       break
     fi
@@ -1272,7 +1275,7 @@
 # Generate a default definition for YACC.  This is used if the makefile can't
 # locate bison or byacc in objdir.
 
-for prog in 'bison -y' byacc yacc
+for prog in "bison${ac_cv_exeext} -y" byacc${ac_cv_exeext} yacc${ac_cv_exeext}
 do
   set dummy $prog; tmp=$2
   IFS="${IFS= 	}"; save_ifs="$IFS"; IFS="${IFS}:"
@@ -1291,7 +1294,7 @@
 # Generate a default definition for M4.  This is used if the makefile can't
 # locate m4 in objdir.
 
-for prog in gm4 gnum4 m4
+for prog in gm4${ac_cv_exeext} gnum4${ac_cv_exeext} m4${ac_cv_exeext}
 do
   set dummy $prog; tmp=$2
   IFS="${IFS=   }"; save_ifs="$IFS"; IFS="${IFS}:"
@@ -1310,7 +1313,7 @@
 # Generate a default definition for LEX.  This is used if the makefile can't
 # locate flex in objdir.
 
-for prog in flex lex
+for prog in flex${ac_cv_exeext} lex${ac_cv_exeext}
 do
   set dummy $prog; tmp=$2
   IFS="${IFS= 	}"; save_ifs="$IFS"; IFS="${IFS}:"
@@ -1348,22 +1351,22 @@
     IFS="${IFS= 	}"; save_ifs="$IFS"; IFS="${IFS}:"
     for dir in $PATH; do
       test -z "$dir" && dir=.
-      if test -f $dir/bison; then
-	YACC="bison -y"
+      if test -f $dir/bison${ac_cv_exeext}; then
+	YACC="bison${ac_cv_exeext} -y"
 	break
       fi
-      if test -f $dir/byacc; then
-	YACC=byacc
+      if test -f $dir/byacc${ac_cv_exeext}; then
+	YACC=byacc${ac_cv_exeext}
 	break
       fi
       if test -f $dir/yacc; then
-	YACC=yacc
+	YACC=yacc${ac_cv_exeext}
 	break
       fi
     done
     IFS="$save_ifs"
     if test -z "${YACC}" ; then
-      YACC="bison -y"
+      YACC="bison${ac_cv_exeext} -y"
     fi
   fi
 
@@ -1371,12 +1374,12 @@
     IFS="${IFS= 	}"; save_ifs="$IFS"; IFS="${IFS}:"
     for dir in $PATH; do
       test -z "$dir" && dir=.
-      if test -f $dir/flex; then
-	LEX=flex
+      if test -f $dir/flex${ac_cv_exeext}; then
+	LEX=flex${ac_cv_exeext}
 	break
       fi
-      if test -f $dir/lex; then
-	LEX=lex
+      if test -f $dir/lex${ac_cv_exeext}; then
+	LEX=lex${ac_cv_exeext}
 	break
       fi
     done
@@ -1408,7 +1411,7 @@
     IFS="${IFS= 	}"; save_ifs="$IFS"; IFS="${IFS}:"
     for dir in $PATH; do
       test -z "$dir" && dir=.
-      if test -f $dir/gcc; then
+      if test -f $dir/gcc${ac_cv_exeext}; then
 	CC="gcc"
 	cc_prog_is_gcc=yes
 	echo 'void f(){}' > conftest.c
Index: src/binutils/gettext.m4
===================================================================
RCS file: /gccos2/src/binutils/gettext.m4,v
retrieving revision 1.1.1.2
retrieving revision 1.7
diff -w -u -r1.1.1.2 -r1.7
--- src/binutils/gettext.m4	16 Aug 2003 16:40:54 -0000	1.1.1.2
+++ src/binutils/gettext.m4	13 Mar 2005 23:43:16 -0000	1.7
@@ -33,6 +33,7 @@
       AC_MSG_RESULT($nls_cv_force_use_gnu_gettext)
 
       nls_cv_use_gnu_gettext="$nls_cv_force_use_gnu_gettext"
+      echo "nls_cv_use_gnu_gettext:$nls_cv_use_gnu_gettext" >&5
       if test "$nls_cv_force_use_gnu_gettext" != "yes"; then
         dnl User does not insist on using GNU NLS library.  Figure out what
         dnl to use.  If gettext or catgets are available (in this order) we
@@ -48,12 +49,16 @@
 	       gt_cv_func_gettext_libc=yes, gt_cv_func_gettext_libc=no)])
 
 	   if test "$gt_cv_func_gettext_libc" != "yes"; then
+             dnl dnl Bird: this is pretty hackish, something aint working right...
+             dnl dnl AC_CHECK_LIB isnt working it seems... its not adding -lintl to LIB...
 	     AC_CHECK_LIB(intl, bindtextdomain,
 	       [AC_CACHE_CHECK([for gettext in libintl],
 		 gt_cv_func_gettext_libintl,
-		 [AC_TRY_LINK([], [return (int) gettext ("")],
+		 [ac_save_LIBS="$LIBS"; LIBS="-lintl $LIBS";
+                 AC_TRY_LINK([#include <libintl.h>], [return (int) gettext ("")],
 		 gt_cv_func_gettext_libintl=yes,
-		 gt_cv_func_gettext_libintl=no)])])
+		 gt_cv_func_gettext_libintl=no)
+                 LIBS="$ac_save_LIBS";])])
 	   fi
 
 	   if test "$gt_cv_func_gettext_libc" = "yes" \
@@ -67,6 +72,7 @@
 		AC_PATH_PROG(GMSGFMT, gmsgfmt, $MSGFMT)
 		AM_PATH_PROG_WITH_TEST(XGETTEXT, xgettext,
 		  [test -z "`$ac_dir/$ac_word -h 2>&1 | grep '(HELP)'`"], :)
+
 		AC_TRY_LINK(, [extern int _nl_msg_cat_cntr;
 			       return _nl_msg_cat_cntr],
 		  [CATOBJEXT=.gmo
@@ -85,6 +91,7 @@
 	  dnl Neither gettext nor catgets in included in the C library.
 	  dnl Fall back on GNU gettext library.
 	  nls_cv_use_gnu_gettext=yes
+          echo "nls_cv_use_gnu_gettext:$nls_cv_use_gnu_gettext fallback" >&5
         fi
       fi
 
@@ -106,6 +113,15 @@
 	LIBS=`echo $LIBS | sed -e 's/-lintl//'`
         nls_cv_header_intl=libintl.h
         nls_cv_header_libgt=libgettext.h
+      dnl else
+      dnl  dnl Bird: AC_CHECK_LIB doesn't seem to work. Update both LIBS and
+      dnl  dnl INTLLIBS just in case LIBS is messed up later.
+      dnl  echo "dbg: else: gt_cv_func_gettext_libintl" >&5
+      dnl  if test "$gt_cv_func_gettext_libintl" = "yes"; then
+      dnl    echo "dbg: updating LIBS" >&5
+      dnl    LIBS="-lintl $LIBS"
+      dnl    INTLLIBS="-lintl"
+      dnl  fi
       fi
 
       dnl Test whether we really found GNU xgettext.
@@ -260,7 +276,9 @@
    if test -f $srcdir/po/POTFILES.in; then
       test -d po || mkdir po
       if test "x$srcdir" != "x."; then
-	 if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
+	 dnl bird: Added a driveletter hack here.
+     dnl old code: if test "x`echo $srcdir | sed 's@/.*@@'`" = "x"; then
+	 if test "x`echo $srcdir | sed -e 's@.\:/.*@@'  -e 's@/.*@@' `" = "x"; then
 	    posrcprefix="$srcdir/"
 	 else
 	    posrcprefix="../$srcdir/"
@@ -292,7 +310,7 @@
 AC_MSG_CHECKING([for $ac_word])
 AC_CACHE_VAL(ac_cv_path_$1,
 [case "[$]$1" in
-  /*)
+  [[/\\]]*|[[a-zA-Z]]:*)
   ac_cv_path_$1="[$]$1" # Let the user override the test with a path.
   ;;
   *)
@@ -305,6 +323,15 @@
 	break
       fi
     fi
+    ac_word_saved="$ac_word"
+    ac_word=$ac_word$ac_cv_exeext
+    if test -f $ac_dir/$ac_word; then
+      if [$3]; then
+	ac_cv_path_$1="$ac_dir/$ac_word"
+	break
+      fi
+    fi
+    ac_word="$ac_word_saved"
   done
   IFS="$ac_save_ifs"
 dnl If no 4th arg is given, leave the cache variable unset,
Index: src/binutils/libtool.m4
===================================================================
RCS file: /gccos2/src/binutils/libtool.m4,v
retrieving revision 1.1.1.2
retrieving revision 1.4
diff -w -u -r1.1.1.2 -r1.4
--- src/binutils/libtool.m4	16 Aug 2003 16:40:55 -0000	1.1.1.2
+++ src/binutils/libtool.m4	29 Jan 2004 18:38:34 -0000	1.4
@@ -659,6 +659,10 @@
   lt_cv_file_magic_test_file=/usr/lib/libnls.so
   ;;
 
+os2*)
+  lt_cv_deplibs_check_method=pass_all
+  ;;
+
 osf3* | osf4* | osf5*)
   # this will be overridden with pass_all, but let us keep it just in case
   lt_cv_deplibs_check_method='file_magic COFF format alpha shared library'
Index: src/binutils/ltcf-c.sh
===================================================================
RCS file: /gccos2/src/binutils/ltcf-c.sh,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/ltcf-c.sh	16 Aug 2003 16:40:56 -0000	1.1.1.2
+++ src/binutils/ltcf-c.sh	2 Feb 2004 00:24:11 -0000	1.5
@@ -485,8 +485,10 @@
   os2*)
     hardcode_libdir_flag_spec='-L$libdir'
     hardcode_minus_L=yes
-    allow_undefined_flag=unsupported
-    archive_cmds='$echo "LIBRARY $libname INITINSTANCE" > $output_objdir/$libname.def~$echo "DESCRIPTION \"$libname\"" >> $output_objdir/$libname.def~$echo DATA >> $output_objdir/$libname.def~$echo " SINGLE NONSHARED" >> $output_objdir/$libname.def~$echo EXPORTS >> $output_objdir/$libname.def~emxexp $libobjs >> $output_objdir/$libname.def~$CC -Zdll -Zcrtdll -o $lib $libobjs $deplibs $compiler_flags $output_objdir/$libname.def'
+    #allow_undefined_flag=unsupported
+    # HACK!!!! just need something here to link shared libs - at least for now.
+    allow_undefined_flag=no
+    archive_cmds='$echo "LIBRARY $soname INITINSTANCE" > $output_objdir/$libname.def~$echo "DESCRIPTION \"$libname\"" >> $output_objdir/$libname.def~$echo DATA >> $output_objdir/$libname.def~$echo " SINGLE NONSHARED" >> $output_objdir/$libname.def~$echo EXPORTS >> $output_objdir/$libname.def~emxexp $libobjs >> $output_objdir/$libname.def~$CC -Zdll -Zcrtdll -o $lib $libobjs $deplibs $compiler_flags ${LT_OS2_LDFLAGS} $output_objdir/$libname.def'
     old_archive_from_new_cmds='emximp -o $output_objdir/$libname.a $output_objdir/$libname.def'
     ;;
 
Index: src/binutils/ltconfig
===================================================================
RCS file: /gccos2/src/binutils/ltconfig,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/ltconfig	16 Aug 2003 16:41:00 -0000	1.1.1.2
+++ src/binutils/ltconfig	16 Aug 2003 21:33:48 -0000	1.5
@@ -1284,11 +1284,31 @@
   ;;
 
 os2*)
-  libname_spec='$name'
+  version_type=linux
+  need_version=no
   need_lib_prefix=no
-  library_names_spec='$libname.dll $libname.a'
+  # embedd versionnumbers into the name as far as there is space for such.
+  # old: libname_spec='$name'
+  # old: library_names_spec='$libname.dll $libname.a'
+  # assumes no dots in the $name.
+  # Man, awk is cute!
+  soname_spec="\`echo \"\${release}...\" | name=\"\${name}\" gawk -- 'BEGIN { FS = \".\"} ; \
+    {  sNum=\"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\"; sVer=\"\"; \
+       if (\$1 != \"\" || \$2 != \"\") { if (\$1 < 0) \$1= -\$1; sVer=substr(sNum,\$1%length(sNum)+1, 1) } \
+       if (\$2 != \"\") { if (\$2 >= length(sNum)) sVer=sVer\"\"substr(sNum,\$2/length(sNum)+1, 1); sVer=sVer\"\"substr(sNum, \$2%length(sNum)+1, 1); } \
+       printf(\"%.*s%s\", 8-length(sVer), ENVIRON[\"name\"], sVer); \
+    } ' \`"
+  libname_spec='lib$name'
+  library_names_spec="\`echo \"\${release}...\" | name=\"\${name}\" gawk -- 'BEGIN { FS = \".\"} ; \
+    {  sNum=\"0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ\"; sVer=\"\"; \
+       if (\$1 != \"\" || \$2 != \"\") { if (\$1 < 0) \$1= -\$1; sVer=substr(sNum,\$1%length(sNum)+1, 1) } \
+       if (\$2 != \"\") { if (\$2 >= length(sNum)) sVer=sVer\"\"substr(sNum,\$2/length(sNum)+1, 1); sVer=sVer\"\"substr(sNum, \$2%length(sNum)+1, 1); } \
+       printf(\"%.*s%s\", 8-length(sVer), ENVIRON[\"name\"], sVer); \
+    } ' \`.dll lib\${name}.a"
   dynamic_linker='OS/2 ld.exe'
-  shlibpath_var=LIBPATH
+  shlibpath_var=BEGINLIBPATH
+  # HACK
+  allow_undefined_flag=no
   ;;
 
 osf3* | osf4* | osf5*)
@@ -1555,7 +1575,7 @@
 # Only try to build win32 dlls if AC_LIBTOOL_WIN32_DLL was used in
 # configure.in, otherwise build static only libraries.
 case $host_os in
-cygwin* | mingw* | pw32* | os2*)
+cygwin* | mingw* | pw32*)
   if test x$can_build_shared = xyes; then
     test x$enable_win32_dll = xno && can_build_shared=no
     echo "checking if package supports dlls... $can_build_shared" 1>&6
Index: src/binutils/ylwrap
===================================================================
RCS file: /gccos2/src/binutils/ylwrap,v
retrieving revision 1.1.1.1
retrieving revision 1.2
diff -w -u -r1.1.1.1 -r1.2
--- src/binutils/ylwrap	16 Apr 2003 14:15:13 -0000	1.1.1.1
+++ src/binutils/ylwrap	16 Dec 2003 22:20:00 -0000	1.2
@@ -31,7 +31,7 @@
 shift
 # Make any relative path in $prog absolute.
 case "$prog" in
- /* | [A-Za-z]:\\*) ;;
+ /* | [A-Za-z]:[\\/]*) ;;
  */*) prog="`pwd`/$prog" ;;
 esac
 
@@ -39,7 +39,7 @@
 input="$1"
 shift
 case "$input" in
- /* | [A-Za-z]:\\*)
+ /* | [A-Za-z]:[\\/]*)
     # Absolute path; do nothing.
     ;;
  *)
@@ -75,7 +75,7 @@
 
 cd $dirname
 case "$input" in
- /* | [A-Za-z]:\\*)
+ /* | [A-Za-z]:[\\/]*)
     # Absolute path; do nothing.
     ;;
  *)
@@ -95,7 +95,7 @@
          # If $2 is an absolute path name, then just use that,
          # otherwise prepend `../'.
          case "$2" in
-	   /* | [A-Za-z]:\\*) target="$2";;
+	   /* | [A-Za-z]:[\\/]*) target="$2";;
 	   *) target="../$2";;
 	 esac
 	 mv "$1" "$target" || status=$?
Index: src/binutils/bfd/acinclude.m4
===================================================================
RCS file: /gccos2/src/binutils/bfd/acinclude.m4,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/bfd/acinclude.m4	16 Aug 2003 16:41:35 -0000	1.1.1.2
+++ src/binutils/bfd/acinclude.m4	16 Aug 2003 21:33:48 -0000	1.3
@@ -3,7 +3,7 @@
 [AC_REQUIRE([AC_CANONICAL_SYSTEM])
 case "${host}" in
 changequote(,)dnl
-*-*-msdos* | *-*-go32* | *-*-mingw32* | *-*-cygwin* | *-*-windows*)
+*-*-msdos* | *-*-go32* | *-*-mingw32* | *-*-cygwin* | *-*-windows* | *-*-os2*)
 changequote([,])dnl
   AC_DEFINE(USE_BINARY_FOPEN, 1, [Use b modifier when opening binary files?]) ;;
 esac])dnl
Index: src/binutils/bfd/aoutx.h
===================================================================
RCS file: /gccos2/src/binutils/bfd/aoutx.h,v
retrieving revision 1.1.1.2
retrieving revision 1.8
diff -w -u -r1.1.1.2 -r1.8
--- src/binutils/bfd/aoutx.h	16 Aug 2003 16:41:47 -0000	1.1.1.2
+++ src/binutils/bfd/aoutx.h	6 Jun 2005 02:42:09 -0000	1.8
@@ -129,6 +129,10 @@
 #include "aout/stab_gnu.h"
 #include "aout/ar.h"
 
+#if defined(N_IMP1) && defined(N_IMP2)
+#define VALUE_N_IMP1 (0xffffffffU)
+#endif
+
 static bfd_boolean aout_get_external_symbols
   PARAMS ((bfd *));
 static bfd_boolean translate_from_native_sym_flags
@@ -275,6 +279,10 @@
 
 #define TABLE_SIZE(TABLE)	(sizeof (TABLE) / sizeof (TABLE[0]))
 
+#ifndef IS_STAB
+#  define IS_STAB(flags) ((flags) & N_STAB)
+#endif
+
 reloc_howto_type *
 NAME(aout,reloc_type_lookup) (abfd,code)
      bfd *abfd;
@@ -1409,7 +1417,7 @@
 {
   flagword visible;
 
-  if ((cache_ptr->type & N_STAB) != 0
+  if (IS_STAB(cache_ptr->type)
       || cache_ptr->type == N_FN)
     {
       asection *sec;
@@ -1650,6 +1658,27 @@
       cache_ptr->symbol.value -= cache_ptr->symbol.section->vma;
       cache_ptr->symbol.flags = BSF_WEAK;
       break;
+
+#if defined(N_IMP1) && defined(N_IMP2)
+    case N_IMP1 | N_EXT:
+      cache_ptr->symbol.section = bfd_abs_section_ptr;
+      cache_ptr->symbol.flags = BSF_EMX_IMPORT1;
+      break;
+
+    case N_IMP2 | N_EXT:
+      cache_ptr->symbol.section = bfd_abs_section_ptr;
+      cache_ptr->symbol.flags = BSF_EMX_IMPORT2;
+      break;
+    case N_IMP2: case N_IMP1: BFD_ASSERT (!"very bad"); break;
+#endif /* EMX: N_IMP[12] */
+
+#if defined(N_EXP)
+      case N_EXP:
+      case N_EXP | N_EXT:
+        cache_ptr->symbol.section = bfd_abs_section_ptr;
+        cache_ptr->symbol.flags = BSF_EMX_EXPORT;
+        break;
+#endif /* EMX: N_EXP */
     }
 
   return TRUE;
@@ -1693,7 +1722,21 @@
     }
 
   if (bfd_is_abs_section (sec))
+    {
+#if defined (N_IMP1) && defined (N_IMP2)
+      if (cache_ptr->flags & BSF_EMX_IMPORT1)
+        sym_pointer->e_type[0] |= N_IMP1;
+      else if (cache_ptr->flags & BSF_EMX_IMPORT2)
+        sym_pointer->e_type[0] |= N_IMP2;
+      else
+#endif
+#if defined(N_EXP)
+      if (cache_ptr->flags & BSF_EMX_EXPORT)
+        sym_pointer->e_type[0] |= N_EXP;
+      else
+#endif /* EMX: N_EXP */
     sym_pointer->e_type[0] |= N_ABS;
+    }
   else if (sec == obj_textsec (abfd))
     sym_pointer->e_type[0] |= N_TEXT;
   else if (sec == obj_datasec (abfd))
@@ -2063,6 +2106,15 @@
   int r_baserel, r_jmptable, r_relative;
   asection *output_section = sym->section->output_section;
 
+  /* bird - start */
+  /* Output reloctions to weak symbols as if they were undefined externals.
+     The aoutx.h code relocates them as if they were nothing special and I can't
+     see the linker doing the right thing either when it processes it. */
+  int is_weak = g->sym_ptr_ptr
+      && *g->sym_ptr_ptr
+      && ((*g->sym_ptr_ptr)->flags & BSF_WEAK);
+  /* bird - end */
+
   PUT_WORD (abfd, g->address, natptr->r_address);
 
   r_length = g->howto->size ;	/* Size as a power of two.  */
@@ -2088,7 +2140,8 @@
 
   if (bfd_is_com_section (output_section)
       || bfd_is_abs_section (output_section)
-      || bfd_is_und_section (output_section))
+      || bfd_is_und_section (output_section)
+      || is_weak)                     /* bird */
     {
       if (bfd_abs_section_ptr->symbol == sym)
 	{
@@ -3210,7 +3263,7 @@
 	 optimization only, as we check the type more thoroughly
 	 below.  */
       if (((type & N_EXT) == 0
-	   || (type & N_STAB) != 0
+	   || IS_STAB(type)
 	   || type == N_FN)
 	  && type != N_WEAKA
 	  && type != N_WEAKT
@@ -3241,7 +3294,11 @@
 	  || type == (N_DATA | N_EXT)
 	  || type == (N_BSS | N_EXT)
 	  || type == (N_ABS | N_EXT)
-	  || type == (N_INDR | N_EXT))
+	  || type == (N_INDR | N_EXT)
+#if defined(N_IMP1) && defined(N_IMP2)
+	  || type == (N_IMP1 | N_EXT)
+#endif
+         )
 	{
 	  /* This object file defines this symbol.  We must link it
 	     in.  This is true regardless of whether the current
@@ -3436,7 +3493,7 @@
       type = H_GET_8 (abfd, p->e_type);
 
       /* Ignore debugging symbols.  */
-      if ((type & N_STAB) != 0)
+      if (IS_STAB(type))
 	continue;
 
       name = strings + GET_WORD (abfd, p->e_strx);
@@ -3556,6 +3613,27 @@
 	  value -= bfd_get_section_vma (abfd, section);
 	  flags = BSF_WEAK;
 	  break;
+#if defined(N_IMP1) && defined(N_IMP2)
+	case N_IMP1 | N_EXT:
+	  section = bfd_abs_section_ptr;
+	  flags = BSF_EMX_IMPORT1;
+          /* VALUE_N_IMP1 in *ABS* means external imported symbol. This is
+             a bit unreliable, but it's the best we can do in some cases. */
+          value = VALUE_N_IMP1;
+	  break;
+	case N_IMP2 | N_EXT:
+	  section = bfd_abs_section_ptr;
+	  flags = BSF_EMX_IMPORT2;
+	  break;
+        case N_IMP2: case N_IMP1: BFD_ASSERT (!"very bad"); break;
+#endif /* EMX: N_IMP[12] */
+#if defined(N_EXP)
+	case N_EXP | N_EXT:
+	case N_EXP:
+	  section = bfd_abs_section_ptr;
+	  flags = BSF_EMX_EXPORT;
+	  break;
+#endif /* EMX: N_EXP */
 	}
 
       if (! ((*add_one_symbol)
@@ -4267,7 +4345,7 @@
 	    case strip_none:
 	      break;
 	    case strip_debugger:
-	      if ((type & N_STAB) != 0)
+	      if (IS_STAB(type))
 		skip = TRUE;
 	      break;
 	    case strip_some:
@@ -4315,7 +4393,16 @@
 	      val = GET_WORD (input_bfd, sym->e_value);
 	      symsec = NULL;
 	    }
-	  else if ((type & N_STAB) != 0)
+#if defined(N_IMP1) && defined(N_IMP2)
+	  else if ((type == (N_IMP1 | N_EXT))
+                || (type == (N_IMP2 | N_EXT)))
+	    symsec = bfd_abs_section_ptr;
+#endif
+#if defined(N_EXP)
+	  else if (type == (N_EXP | N_EXT))
+	    symsec = bfd_abs_section_ptr;
+#endif /* EMX: N_EXP */
+	  else if (IS_STAB(type))
 	    {
 	      val = GET_WORD (input_bfd, sym->e_value);
 	      symsec = NULL;
@@ -4394,6 +4481,10 @@
 		    type |= (hresolve->root.type == bfd_link_hash_defined
 			     ? N_BSS
 			     : N_WEAKB);
+#if defined(N_IMP1) && defined(N_IMP2)
+                  else if (hresolve->root.u.def.value == VALUE_N_IMP1)
+                    type |= N_IMP1;
+#endif
 		  else
 		    type |= (hresolve->root.type == bfd_link_hash_defined
 			     ? N_ABS
@@ -4433,7 +4524,7 @@
 		case discard_sec_merge:
 		  break;
 		case discard_l:
-		  if ((type & N_STAB) == 0
+		  if (!IS_STAB(type)
 		      && bfd_is_local_label_name (input_bfd, name))
 		    skip = TRUE;
 		  break;
@@ -4677,6 +4768,10 @@
 	  type = h->root.type == bfd_link_hash_defined ? N_DATA : N_WEAKD;
 	else if (sec == obj_bsssec (output_bfd))
 	  type = h->root.type == bfd_link_hash_defined ? N_BSS : N_WEAKB;
+#if defined(N_IMP1) && defined(N_IMP2)
+        else if (h->root.u.def.value == VALUE_N_IMP1)
+          type = N_IMP1;
+#endif
 	else
 	  type = h->root.type == bfd_link_hash_defined ? N_ABS : N_WEAKA;
 	type |= N_EXT;
@@ -4946,6 +5041,11 @@
 		 is what the native linker does.  */
 	      h = sym_hashes[r_index];
 	      if (h != (struct aout_link_hash_entry *) NULL
+#ifdef EMX
+              /* Don't touch imported symbols */
+                  && (!bfd_is_abs_section (h->root.u.def.section)
+                      || (h->root.u.def.value != (unsigned)-1))
+#endif
 		  && (h->root.type == bfd_link_hash_defined
 		      || h->root.type == bfd_link_hash_defweak))
 		{
Index: src/binutils/bfd/archive.c
===================================================================
RCS file: /gccos2/src/binutils/bfd/archive.c,v
retrieving revision 1.1.1.2
retrieving revision 1.3
diff -w -u -r1.1.1.2 -r1.3
--- src/binutils/bfd/archive.c	16 Aug 2003 16:41:50 -0000	1.1.1.2
+++ src/binutils/bfd/archive.c	16 Aug 2003 21:33:48 -0000	1.3
@@ -1909,6 +1909,9 @@
 		  if ((flags & BSF_GLOBAL ||
 		       flags & BSF_WEAK ||
 		       flags & BSF_INDIRECT ||
+#ifdef EMX
+		       flags & BSF_EMX_IMPORT1 ||
+#endif /* EMX */
 		       bfd_is_com_section (sec))
 		      && ! bfd_is_und_section (sec))
 		    {
Index: src/binutils/bfd/bfd-in2.h
===================================================================
RCS file: /gccos2/src/binutils/bfd/bfd-in2.h,v
retrieving revision 1.1.1.2
retrieving revision 1.5
diff -w -u -r1.1.1.2 -r1.5
--- src/binutils/bfd/bfd-in2.h	16 Aug 2003 16:41:55 -0000	1.1.1.2
+++ src/binutils/bfd/bfd-in2.h	6 Jun 2005 02:42:09 -0000	1.5
@@ -3591,6 +3591,15 @@
 
   /* This symbol is thread local.  Used in ELF.  */
 #define BSF_THREAD_LOCAL  0x40000
+
+  /* Symbol is an emx export definition.  */
+#define BSF_EMX_EXPORT   0x10000000
+
+  /* Symbol is an emx import reference.  */
+#define BSF_EMX_IMPORT1   0x20000000
+
+  /* Symbol is an emx import definition.  */
+#define BSF_EMX_IMPORT2   0x40000000
 
   flagword flags;
 
Index: src/binutils/bfd/config.bfd
===================================================================
RCS file: /gccos2/src/binutils/bfd/config.bfd,v
retrieving revision 1.1.1.2
retrieving revision 1.6
diff -w -u -r1.1.1.2 -r1.6
--- src/binutils/bfd/config.bfd	16 Aug 2003 16:42:53 -0000	1.1.1.2
+++ src/binutils/bfd/config.bfd	16 Feb 2004 03:45:30 -0000	1.6
@@ -542,6 +542,16 @@
     targ_defvec=bfd_elf32_i386_vec
     targ_selfvecs=i386chaos_vec
     ;;
+  i[3456]86-*-os2-elf)
+    targ_defvec=bfd_elf32_i386_vec
+    targ_selvecs="bfd_elf32_i386_vec i386aout_emx_vec bfd_efi_app_ia32_vec i386pe_vec i386pei_vec"
+    targ_underscore=yes
+    ;;
+  i[3456]86-*-os2*)
+    targ_defvec=i386aout_emx_vec
+    targ_selvecs="i386aout_emx_vec bfd_elf32_i386_vec bfd_efi_app_ia32_vec i386pe_vec i386pei_vec"
+    targ_underscore=yes
+    ;;
 
   i860-*-mach3* | i860-*-osf1* | i860-*-coff*)
     targ_defvec=i860coff_vec
@@ -1247,6 +1257,7 @@
     targ_defvec=m68kcoff_vec
     targ_selvecs=ieee_vec
     ;;
+
 # END OF targmatch.h
   *)
     echo 1>&2 "*** BFD does not support target ${targ}."
Index: src/binutils/bfd/configure.in
===================================================================
RCS file: /gccos2/src/binutils/bfd/configure.in,v
retrieving revision 1.1.1.2
retrieving revision 1.8
diff -w -u -r1.1.1.2 -r1.8
--- src/binutils/bfd/configure.in	16 Aug 2003 16:42:57 -0000	1.1.1.2
+++ src/binutils/bfd/configure.in	13 Mar 2005 23:44:50 -0000	1.8
@@ -103,7 +103,7 @@
 
 AC_PROG_CC
 
-ALL_LINGUAS="fr tr ja es sv da zh_CN"
+ALL_LINGUAS="fr ja es sv da zh_CN"
 CY_GNU_GETTEXT
 
 # Permit host specific settings.
@@ -241,7 +241,11 @@
 changequote(,)dnl
   i[3456]86-*-isc*)	COREFILE=trad-core.lo ;;
   i[3456]86-*-aix*)	COREFILE=aix386-core.lo ;;
+  i[3456]86-*-os2*)
 changequote([,])dnl
+	COREFILE=trad-core.lo
+	TRAD_HEADER='"hosts/i386emx.h"'
+	;;
   i860-*-mach3* | i860-*-osf1*)
 	COREFILE=trad-core.lo
 	TRAD_HEADER='"hosts/i860mach3.h"'
@@ -428,6 +432,13 @@
     WIN32LIBADD="-L`pwd`/../libiberty -liberty -L`pwd`/../intl -lintl -lcygwin -lkernel32"
   fi
   ;;
+*-*-os2*)
+  if test "$enable_shared" = "yes"; then
+    WIN32LDFLAGS="-no-undefined"
+    WIN32LIBADD="-L`pwd`/../libiberty -liberty"
+#    WIN32LIBADD="-L`pwd`/../libiberty -liberty -L`pwd`/../intl -lintl"
+  fi
+  ;;
 *-*-linux*)
   # We borrow WIN32LIBADD so that the shared libbfd won't depend on
   # libiberty.a.
@@ -698,6 +709,7 @@
     i386msdos_vec)		tb="$tb i386msdos.lo" ;;
     i386netbsd_vec)		tb="$tb i386netbsd.lo aout32.lo" ;;
     i386os9k_vec)		tb="$tb i386os9k.lo aout32.lo" ;;
+    i386aout_emx_vec)		tb="$tb i386aoutemx.lo aout32.lo" ;;
     i386pe_vec)			tb="$tb pe-i386.lo peigen.lo cofflink.lo" ;;
     i386pei_vec)		tb="$tb pei-i386.lo peigen.lo cofflink.lo" ;;
     i860coff_vec)		tb="$tb coff-i860.lo cofflink.lo" ;;
